# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/power/supply/qcom/qpnp-smblite.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Qualcomm Technologies, Inc. SMBLITE Charger.

maintainers:
  - Kamal Wadhwa <quic_kamalw@quicinc.com>

description: |
  SMBLITE Charger is an efficient programmable battery charger capable of charging a
  lithium-ion battery over micro-USB or USB Type-C.

  Required Node Structure:
  SMBLITE Charger must be described in two levels of devices nodes.

properties:
  compatible:
    enum:
      - qcom,qpnp-smblite
      - qcom,qpnp-pm5100-smblite

  qcom,pmic-revid:
    description: |
      Should specify the phandle of PMI's revid module. This is used to
      identify the PMI subtype.
    $ref: /schemas/types.yaml#/definitions/uint32

  "#io-channel-cells":
    const: 1

  "#address-cells":
    const: 1

  "#size-cells":
    const: 0

  io-channels:
    description: Phandle of IIO channels required.

  io-channel-names:
    description: |
      For details about IIO bindings see:
      Documentation/devicetree/bindings/iio/iio-bindings.txt

  qcom,batteryless-platform:
    description: |
      Boolean flag which indicates that the platform does not have a
      battery, and therefore charging should be disabled. In
      addition battery properties will be faked such that the device
      assumes normal operation.
    $ref: /schemas/types.yaml#/definitions/flag

  qcom,fcc-max-ua:
    description: |
      Specifies the maximum fast charge current in micro-amps in
      battery profile.If the value is not present, 1Amp is used as default.
    default: 1000000
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,fv-max-uv:
    description: |
      Specifies the maximum float voltage in micro-volts in
      battery profile.If the value is not present, 4.35V is used as default.
    default: 4350000
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,usb-icl-ua:
    description: |
      Specifies the USB input current limit in micro-amps.
      If the value is not present, 1.5Amps is used as default.
    default: 1500000
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,thermal-mitigation:
    description: |
      Array of fast charge current limit values for
      different system thermal mitigation levels.
      This should be a flat array that denotes the
      maximum charge current in mA for each thermal
      level.
    $ref: /schemas/types.yaml#/definitions/uint32-array

  qcom,chg-inhibit-threshold-mv:
    description: |
      Charge inhibit threshold in milli-volts. Charging will be
      inhibited when the battery voltage is within this threshold
      from Vfloat at charger insertion. If this is not specified
      then charge inhibit will be disabled by default.
      Allowed values are: 50, 100, 200, 300.
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,chg-term-src:
    description: |
      Specify either the ADC or analog comparators to be used in order
      to set threshold values for charge termination current.
      0 - Unspecified
      1 - Select ADC comparator
      2 - Select ANALOG comparator
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,chg-term-current-ma:
    description: |
      When ADC comparator is selected as qcom,chg-term-src, this
      parameter should be set to the desired upper threshold.
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,chg-term-base-current-ma:
    description: |
      When ADC comparator is selected as qcom,chg-term-src, this
      parameter should be set to the desired lower threshold.
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,auto-recharge-soc:
    description: |
      Specifies the SOC threshold at which the charger will
      restart charging after termination. The value specified
      ranges from 0 - 100. The feature is enabled if this
      property is specified with a valid SOC value.
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,auto-recharge-vbat-mv:
    description: |
      Specifies the battery voltage threshold at which the charger
      will restart charging after termination. The value specified
      is in milli-volts.
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,suspend-input-on-debug-batt:
    description: |
      Boolean flag which when present enables input suspend for
      debug battery.
    $ref: /schemas/types.yaml#/definitions/flag

  qcom,fake-chg-status-on-debug-batt:
    description: |
      Boolean flag which when present shows charging status as
      unknown for debug battery. This needs to be specified only if
      the device needs to be kept powered on always with
      "svc power stayon true".
    $ref: /schemas/types.yaml#/definitions/flag

  qcom,typec-legacy-rp-icl:
    description: |
      Boolean property to enable setting ICL based on Rp for
      Type-C non-compliant legacy cables.
    $ref: /schemas/types.yaml#/definitions/flag

  qcom,wd-bark-time-secs:
    description: |
      WD bark-timeout in seconds. The possible values are
      16, 32, 64, 128. If not defined it defaults to 64.
    default: 64
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,battery-data:
    description: |
      Specifies the phandle of the node which contains the battery
      profiles supported on the device.

    $ref: /schemas/types.yaml#/definitions/phandle

  qcom,flash-derating-soc:
    description: |
      SOC threshold in percentage below which hardware will start
      derating flash. This is only applicable to certain PMICs like
      PMI632 which has SCHGM_FLASH peripheral.
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,flash-disable-soc:
    description: |
      SOC threshold in percentage below which hardware will disable
      flash. This is only applicable to certain PMICs like PMI632
      which has SCHGM_FLASH peripheral.
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,headroom-mode:
    description: |
      Specifies flash hardware headroom management policy.
      The possible values are:
      <0>: Fixed mode, constant 5V at flash input.
      <1>: Adaptive mode allows charger output voltage to be
      dynamically controlled by the flash module based on the
      required flash headroom.
      This is only applicable to certain PMICs like PMI632 which
      has SCHGM_FLASH peripheral.
    $ref: /schemas/types.yaml#/definitions/uint32

  nvmem-cell-names:
    description: |
      The nvmem cell device name of the SDAM register used to store
      the charger debug mask. It must be "charger_debug_mask".
    $ref: /schemas/types.yaml#/definitions/string

  nvmem-cells:
    description: |
      Phandle of the nvmem cell device used to store the charger debug
      mask. Please refer to nvmem bindings as described in
      bindings/nvmem/nvmem.txt.

  qcom,fcc-stepping-enable:
    description: |
      Boolean flag which when present enables stepwise change in FCC.
      The default stepping rate is 100mA/sec.
    $ref: /schemas/types.yaml#/definitions/flag

  qcom,disable-suspend-on-collapse:
    description: |
      Boolean flag which when present disables suspend on collapse
      feature of charger hardware.
    $ref: /schemas/types.yaml#/definitions/flag

  qcom,fcc-step-delay-ms:
    description: |
      Specifies the delay between each step of FCC stepper algorithm.
      If left unspecified, the default value is 1 Sec.
    default: 1000

  qcom,fcc-step-size-ua:
    description: |
      Specifies the step size of each step of FCC stepper algorithm.
      If left unspecified, the default value is 100mA.
    default: 100000
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,fc-step-start-ua:
    description: |
      Specifies the initial current of FCC stepper algorithm.
      If left unspecified, the default value is 500mA.
    default: 500000
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,concurrency-mode-enable:
    description: |
      Boolean flag to control charger concurrency mode. Its supported
      only on PM5100, By default this feature is disabled.
    $ref: /schemas/types.yaml#/definitions/flag

  qcom,remote-fg:
    description: |
      Boolean flag to determine if FG is running on different processor.
      Its supported only on PM5100, By default this feature is disabled.
    $ref: /schemas/types.yaml#/definitions/flag

  qcom,float-option:
    description: |
      Configures how the charger behaves when a float charger is
      detected by APSD.
      1 - Treat as a DCP.
      2 - Treat as a SDP.
      3 - Disable charging.
      4 - Suspend USB input.
    $ref: /schemas/types.yaml#/definitions/uint32

  qcom,uusb-ss-mode-extcon-enable:
    description: |
      Boolean flag to support board designs with Micro-AB 3.0 USB port.
      If this is enabled, on USB plugin event SS mode extcon notification
      is sent  (instead of an HS mode). This DT property should be defined
      only if the board is not expected to support Micro-B type USB cable
      on the Micro-AB 3.0 port, as the Micro-B cable cannot support SS mode.
      By default this feature is disabled.
    $ref: /schemas/types.yaml#/definitions/flag

additionalProperties: false

required:
  - compatible

patternProperties:
  "^qcom,chgr@[0-9a-f].*$":
    type: object

    properties:
      reg:
        description: Address and size of the peripheral's register block.

      interrupts:
        description: Peripheral interrupt specifier.

      interrupt-names:
        description: |
          Interrupt names.  This list must match up 1-to-1 with the
          interrupts specified in the 'interrupts' property.

    required:
      - reg
      - interrupts
      - interrupt-names

  "^qcom,dcdc@[0-9a-f].*$":
    type: object

    properties:
      reg:
        description: Address and size of the peripheral's register block.

      interrupts:
        description: Peripheral interrupt specifier.

      interrupt-names:
        description: |
          Interrupt names.  This list must match up 1-to-1 with the
          interrupts specified in the 'interrupts' property.

    required:
      - reg
      - interrupts
      - interrupt-names

  "^qcom,batif@[0-9a-f].*$":
    type: object
    description: regulator client voting interface node(s).

    properties:
      reg:
        description: Address and size of the peripheral's register block.

      interrupts:
        description: Peripheral interrupt specifier.

      interrupt-names:
        description: |
          Interrupt names.  This list must match up 1-to-1 with the
          interrupts specified in the 'interrupts' property.

    required:
      - reg
      - interrupts
      - interrupt-names

  "^qcom,usb@[0-9a-f].*$":
    type: object

    properties:
      reg:
        description: Address and size of the peripheral's register block.

      interrupts:
        description: Peripheral interrupt specifier.

      interrupt-names:
        description: |
          Interrupt names.  This list must match up 1-to-1 with the
          interrupts specified in the 'interrupts' property.

    required:
      - reg
      - interrupts
      - interrupt-names

  "^qcom,typec@[0-9a-f].*$":
    type: object

    properties:
      reg:
        description: Address and size of the peripheral's register block.

      interrupts:
        description: Peripheral interrupt specifier.

      interrupt-names:
        description: |
          Interrupt names.  This list must match up 1-to-1 with the
          interrupts specified in the 'interrupts' property.

    required:
      - reg
      - interrupts
      - interrupt-names

  "^qcom,misc@[0-9a-f].*$":
    type: object

    properties:
      reg:
        description: Address and size of the peripheral's register block.

      interrupts:
        description: Peripheral interrupt specifier.

      interrupt-names:
        description: |
          Interrupt names.  This list must match up 1-to-1 with the
          interrupts specified in the 'interrupts' property.

    required:
      - reg
      - interrupts
      - interrupt-names

examples:
  - |
    #include <dt-bindings/interrupt-controller/irq.h>
    pm2250_charger: qcom,qpnp-smblite {
    compatible = "qcom,qpnp-smblite";
    #address-cells = <1>;
    #size-cells = <0>;

    qcom,chgr@1000 {
        reg = <0x1000>;
        interrupts =
            <0x0 0x10 0x1 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x10 0x0 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x10 0x4 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x10 0x7 IRQ_TYPE_EDGE_RISING>;

        interrupt-names = "chgr-error",
            "chg-state-change",
            "buck-oc",
            "vph-ov";
     };

    qcom,dcdc@1100 {
        reg = <0x1100>;
        interrupts =
            <0x0 0x11 0x0 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x11 0x1 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x11 0x2 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x11 0x6 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x11 0x7 IRQ_TYPE_EDGE_BOTH>;

        interrupt-names = "otg-fail",
            "otg-fault",
            "skip-mode",
            "input-current-limiting",
            "switcher-power-ok";
     };

    qcom,batif@1200 {
        reg = <0x1200>;
        interrupts =
            <0x0 0x12 0x0 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x12 0x1 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x12 0x2 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x12 0x3 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x12 0x4 IRQ_TYPE_EDGE_RISING>;

        interrupt-names = "bat-temp",
            "bat-therm-or-id-missing",
            "bat-low",
            "bat-ov",
            "bsm-active";
     };

    qcom,usb@1300 {
        reg = <0x1300>;
        interrupts =
            <0x0 0x13 0x0 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x13 0x1 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x13 0x2 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x13 0x3 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x13 0x4 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x13 0x6 IRQ_TYPE_EDGE_RISING>;

        interrupt-names = "usbin-plugin",
            "usbin-collapse",
            "usbin-uv",
            "usbin-ov",
            "usbin-gtvt",
            "usbin-icl-change";
     };

    qcom,typec@1500 {
        reg = <0x1500>;
        interrupts =
            <0x0 0x15 0x0 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x15 0x1 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x15 0x2 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x15 0x4 IRQ_TYPE_EDGE_BOTH>,
            <0x0 0x15 0x5 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x15 0x6 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x15 0x7 IRQ_TYPE_EDGE_RISING>;

        interrupt-names = "typec-or-rid-detect-change",
            "typec-vpd-detect",
            "typec-cc-state-change",
            "typec-vbus-change",
            "typec-attach-detach",
            "typec-legacy-cable-detect",
            "typec-try-snk-src-detect";
     };

    qcom,misc@1600 {
        reg = <0x1600>;
        interrupts =
            <0x0 0x16 0x0 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x16 0x1 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x16 0x2 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x16 0x3 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x16 0x4 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x16 0x5 IRQ_TYPE_EDGE_RISING>,
            <0x0 0x16 0x6 IRQ_TYPE_EDGE_BOTH>;

        interrupt-names = "wdog-snarl",
            "wdog-bark",
            "aicl-fail",
            "aicl-done",
            "imp-trigger",
            "all-chnl-cond-done",
            "temp-change";
     };
    };
...
